#pragma once

#include "NWindowsVersion.h"

#include <stdio.h>

#pragma warning(push)
#pragma warning(disable:4201)
#include <mmsystem.h>
#pragma warning(pop)

#include <dsound.h>
#include <dxerr.h>

class NWaveFileHeader
{
public:
	NWaveFileHeader() {ZeroMemory(this, sizeof(NWaveFileHeader));}

	void LoadWAVHeaderFromFile(FILE* file);

	DWORD ChunkID;
	DWORD ChunkSize;
	DWORD Format;
	DWORD Subchunk1ID;
	DWORD Subchunk1Size;
	WORD AudioFormat;
	WORD NumChannels;
	DWORD SampleRate;
	DWORD ByteRate;
	WORD BlockAlign;
	WORD BitsPerSample;
	DWORD Subchunk2ID;
	DWORD Subchunk2Size;
};

class Sound;
class SoundInst;

class SoundInst
{
public:
	SoundInst();
	~SoundInst();

	void Play(Sound* Template);

	IDirectSoundBuffer8* DupBuffer;
	HANDLE hMyEvent;

	static DWORD WINAPI OnFinished(void* data);
};

class Sound
{
public:
	Sound();
	~Sound();

	void Load(const char* Filename);
	SoundInst* Play();

	NWaveFileHeader Header;

	WAVEFORMATEX Format;
	DSBUFFERDESC BufferDesc;
	IDirectSoundBuffer8* Buffer;
	DSBCAPS BufferCaps;
};

class Audio
{
private:
	Audio() {}

public:
	static void Init(HWND hWnd);
	static void Deinit();

	static IDirectSound8* mDevice;
};
