#pragma once

#include "NWindowsVersion.h"
#include "NImage.h"
#include "MaskedImage.h"
#include "Audio.h"
#include "NVec2.h"
#include "Thing.h"
#include "Particle.h"
#include <vector>

class Globals
{
private:
	Globals() {}

public:

	static int GAME_WIDTH;
	static int GAME_HEIGHT;
	static int GAME_SCALE;
	static float RENDER_THRESHOLD;
	static float SORT_THRESHOLD;
	static float COMPOSE_THRESHOLD_MIN;
	static float COMPOSE_THRESHOLD_MAX;
	static float COMPOSE_THRESHOLD_DROP;
	static float COMPOSE_THRESHOLD_LOWEST;

	static int GRACE_ADDRESSES;
	static int MAX_MAIL_IN_FLIGHT;

	static int DELIVERY_SUCCESSES;			// How many letters were correctly delivered to an address or the vortex
	static int DELIVERY_FAILURES;			// How many letters were incorrectly delivered to an address or the vortex
	static int DELIVERY_SATISFIED;			// How many letters, of those correctly delivered to an address, arrived in time
	static int DELIVERY_UNSATISFIED;		// How many letters, of those correctly delivered to an address, did not arrive in time
	static int DELIVERY_TOTAL_COUNT;		// How many letters were correctly delivered to an address
	static float DELIVERY_TOTAL_TIME;		// The total time of all correct deliveries to addresses

	static int NUM_DOMES;
	static float PART_LIFE;

	// Double buffer in case it becomes useful. Right now it's probably just slowing things down.
	static NImage Backbuffer1;
	static NImage Backbuffer2;
	static NImage* Backbuffer;

	static NImage Backdrop;

	static NImage MailOut;

	static MaskedImage Numerals;
	static MaskedImage BlackHole;

	// Ordered bottom to top. When we click something, we move it to the back (end, top) of the vector.
	static std::vector<std::vector<Thing*> > Objects;

	static HWND gWnd;
	static HDC gDC;

	static Sound Sound_Compose;
	static Sound Sound_MailIn;
	static Sound Sound_MailOut;
	static Sound Sound_Success;
	static Sound Sound_Strike;
	static Sound Sound_TooSlow;
	static Sound Sound_Vortex;

	static float LastRenderTime;
	static float LastSortTime;
	static float NextComposeTime;

	static Thing* Dragging;
	static NVec2 DragOffset;

	static std::vector<Particle> InParticles;
	static std::vector<Particle> OutParticles;

	static float DELIVERY_TIME_LIMIT;

	static float GAME_TIME_LIMIT;

	static bool GAME_STARTED;
	static bool GAME_OVER;
};
