#include "main.h"

bool Finished()
{
	bool bRetVal = false;

	MSG msg;
	while (PeekMessage(&msg,NULL,0,0,PM_REMOVE))
	{
		if (msg.message == WM_QUIT)
		{
			bRetVal = true;
		}

		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return bRetVal;
}

void UpdateGame(float DeltaTime)
{
	// See whether we can compose a new message
	if (Globals::GAME_STARTED)
	{
		float AbsTime = gTimer->getAbsoluteTime();

		if (AbsTime >= Globals::NextComposeTime)
		{
			Globals::NextComposeTime = AbsTime + ((random_fl() * (Globals::COMPOSE_THRESHOLD_MAX - Globals::COMPOSE_THRESHOLD_MIN)) + (Globals::COMPOSE_THRESHOLD_MIN));

			if (Globals::GAME_TIME_LIMIT - AbsTime <= 0.0f)
			{
				// Stop generating new mail and watch for an opportunity to end the game
				if ((int)(Globals::Objects[1].size() + Globals::Objects[3].size()) == 0)
				{
					// End!!
					Globals::GAME_OVER = true;
				}
			}
			else
			{
				if ((int)(Globals::Objects[1].size() + Globals::Objects[3].size()) < Globals::MAX_MAIL_IN_FLIGHT)
				{
					Globals::COMPOSE_THRESHOLD_MIN = Max(Globals::COMPOSE_THRESHOLD_LOWEST, Globals::COMPOSE_THRESHOLD_MIN - Globals::COMPOSE_THRESHOLD_DROP);

					Mail* NewMail = new Mail();
					NewMail->bDraggable = true;
					NewMail->Sprite.Load("mail_in.bmp", NColor8(255,0,255));
					NewMail->Extents = NVec2((float)NewMail->Sprite.Sprite.getWidth() * 0.5f, (float)NewMail->Sprite.Sprite.getHeight() * 0.5f);

					// The first five things in Objects[0] are always the domes.
					int DomeIndex = random_fl(5, 0);
					Dome* Origin = (Dome*)(Globals::Objects[0][DomeIndex]);

					NewMail->OriginAddress = Origin->Address;
					NewMail->Pos = Origin->Pos;
					NewMail->Pos.y -= 8.0f;
					NewMail->bTargeting = true;
					NewMail->TargetPos = NewMail->Pos;
					NewMail->TargetPos.y -= 24.0f;
					NewMail->WanderMag = 0.0f;
					NewMail->TargetWanderMag = 8.0f;
					NewMail->OriginTime = AbsTime;

					Globals::Objects[3].push_back(NewMail);

					Globals::Sound_Compose.Play();
				}
			}
		}
	}

	for (int i = 0; i < Globals::NUM_DOMES; ++i)
	{
		Thing* SomeDome = Globals::Objects[0][i];

		float Angle = ((float(i) / float(Globals::NUM_DOMES)) + (gTimer->getAbsoluteTime() * 0.02f)) * TAU;
		NVec2 Pos;
		Pos.x = cos(Angle);
		Pos.y = sin(Angle);

		Pos.x *= ((float(Globals::GAME_WIDTH) * 0.75f * 0.5f) - 32.0f);
		Pos.y *= ((float(Globals::GAME_HEIGHT) * 0.75f * 0.5f) - 32.0f);

		Pos.x += (float(Globals::GAME_WIDTH) * 0.75f * 0.5f);
		Pos.y += (float(Globals::GAME_HEIGHT) * 0.75f * 0.5f) + (float(Globals::GAME_HEIGHT) * 0.25f);

		SomeDome->Pos.x = Pos.x;
		SomeDome->Pos.y = Pos.y;
	}

	for (int i = 0; i < (int)Globals::InParticles.size(); ++i)
	{
		Globals::InParticles[i].Pos.x = Smooth(Globals::InParticles[i].Pos.x, Globals::GAME_WIDTH * 0.875f, 2.0f, DeltaTime);
		Globals::InParticles[i].Pos.y += (DeltaTime * 32.0f);
		Globals::InParticles[i].Life -= DeltaTime;

		while (Globals::InParticles[i].Life < 0.0f)
		{
			Globals::InParticles[i].Life += Globals::PART_LIFE;

			Globals::InParticles[i].Pos.x = float(Globals::GAME_WIDTH) * 0.875f;
			Globals::InParticles[i].Pos.y = float(Globals::GAME_HEIGHT) * 0.125f;

			Globals::InParticles[i].Pos.x += (random_fl() - 0.5f) * 48.0f;
			Globals::InParticles[i].Pos.y += (random_fl() - 0.5f) * 48.0f;
		}
	}

	for (int i = 0; i < (int)Globals::OutParticles.size(); ++i)
	{
		Globals::OutParticles[i].Pos.x -= (Smooth(Globals::OutParticles[i].Pos.x, Globals::GAME_WIDTH * 0.875f, 0.5f, DeltaTime) - Globals::OutParticles[i].Pos.x);
		Globals::OutParticles[i].Pos.y += (DeltaTime * 32.0f);
		Globals::OutParticles[i].Life -= DeltaTime;

		while (Globals::OutParticles[i].Life < 0.0f)
		{
			Globals::OutParticles[i].Life += Globals::PART_LIFE;

			Globals::OutParticles[i].Pos.x = float(Globals::GAME_WIDTH) * 0.875f;
			Globals::OutParticles[i].Pos.y = float(Globals::GAME_HEIGHT) * 0.825f;

			Globals::OutParticles[i].Pos.x += (random_fl() - 0.5f) * 32.0f;
			Globals::OutParticles[i].Pos.y += (random_fl() - 0.5f) * 32.0f;
		}
	}

	for (int i = 0; i < (int)Globals::Objects[1].size(); ++i)
	{
		Thing* ThisThing = Globals::Objects[1][i];
		if (ThisThing)
		{
			Mail* ThisMail = (Mail*)(ThisThing);
			ThisMail->TargetWanderMag = 0.0f;

			float PreY = Globals::Objects[1][i]->Pos.y;

			float OffX = fabs(Globals::Objects[1][i]->Pos.x - Globals::GAME_WIDTH * 0.875f);

			Globals::Objects[1][i]->Pos.x = Smooth(Globals::Objects[1][i]->Pos.x, Globals::GAME_WIDTH * 0.875f, 2.5f, DeltaTime);
			Globals::Objects[1][i]->Pos.y += (DeltaTime * 32.0f);
			Globals::Objects[1][i]->Pos.y -= (OffX * DeltaTime * (Globals::Objects[1][i]->Pos.y * 0.1f));

			float PostY = Globals::Objects[1][i]->Pos.y;

			if (PreY < 90.0f && PostY >= 90.0f)
			{
				float AbsTime = gTimer->getAbsoluteTime();
				if ((AbsTime - Globals::LastSortTime) >= Globals::SORT_THRESHOLD)
				{
					Globals::LastSortTime = AbsTime;

					// Assign it an address and let it move!
					ThisMail->AssignAddress();
				}
				else
				{
					// Put it in a holding pattern until we can deal with it.
					Globals::Objects[1][i]->Pos.y = PreY;
				}
			}

			if (PreY < 144.0f && PostY >= 144.0f)
			{
				// Find a landing position and move this back into Objects[3].
				Globals::Objects[1].erase(Globals::Objects[1].begin() + i);
				Globals::Objects[3].push_back(ThisMail);
				i--;

				ThisMail->TargetWanderMag = 8.0f;
				ThisMail->bTargeting = true;
				ThisMail->TargetPos = NVec2(Globals::GAME_WIDTH * 0.875f, 160.0f);
				ThisMail->TargetPos.x += ((random_fl() - 0.5f) * 16.0f);
				ThisMail->TargetPos.y += ((random_fl() - 0.5f) * 8.0f);

				Globals::Sound_MailOut.Play();
			}
		}
	}

	// Objects[1] and Objects[3] only contain Mail objects.
	for (int i = 0; i < (int)Globals::Objects[1].size(); ++i)
	{
		Mail* ThisMail = (Mail*)(Globals::Objects[1][i]);
		ThisMail->UpdateWander(gTimer->getAbsoluteTime(), DeltaTime);
		ThisMail->UpdateTarget(gTimer->getAbsoluteTime(), DeltaTime);
	}
	for (int i = 0; i < (int)Globals::Objects[3].size(); ++i)
	{
		Mail* ThisMail = (Mail*)(Globals::Objects[3][i]);
		ThisMail->UpdateWander(gTimer->getAbsoluteTime(), DeltaTime);
		ThisMail->UpdateTarget(gTimer->getAbsoluteTime(), DeltaTime);
	}
}

void ClearObjects(std::vector<Thing*>& Objects)
{
	for (int i = 0; i < (int)Objects.size(); ++i)
	{
		SafeDelete(Objects[i]);
	}
	Objects.clear();
}

void DrawObjects(std::vector<Thing*>& Objects)
{
	for (int i = 0; i < (int)Objects.size(); ++i)
	{
		Thing* ThisObj = Objects[i];

		NVec2 Pos = ThisObj->GetPos() - ThisObj->Extents;
		ThisObj->Sprite.Blit(Globals::Backbuffer->getHDC(), (int)Pos.x, (int)Pos.y, 0, 0, ThisObj->Sprite.Sprite.getWidth(), ThisObj->Sprite.Sprite.getHeight());
	}
}

void DrawParticles(std::vector<Particle>& Particles)
{
	for (int i = 0; i < (int)Particles.size(); ++i)
	{
		Globals::Backbuffer->setPixel((int)Particles[i].Pos.x, (int)Particles[i].Pos.y, NColor8(160,112,96));
	}
}

void UpdateRender(float DeltaTime)
{
	float AbsTime = gTimer->getAbsoluteTime();

	int BGScroll = int(gTimer->getAbsoluteTime() * 5.0f);
	BGScroll = (BGScroll % Globals::Backdrop.getWidth());
	//BGScroll = Globals::Backdrop.getWidth() - BGScroll;

	NBlitter::Blit(*(Globals::Backbuffer), Globals::Backdrop, BGScroll, 0, 0, 0, Globals::GAME_WIDTH - BGScroll, Globals::GAME_HEIGHT, false);
	NBlitter::Blit(*(Globals::Backbuffer), Globals::Backdrop, 0, 0, Globals::GAME_WIDTH - BGScroll, 0, BGScroll, Globals::GAME_HEIGHT, false);

	{
		int BlackHoleFrame = int(gTimer->getAbsoluteTime() * 10.0f);
		int NumBlackHoleFrames = Globals::BlackHole.Sprite.getWidth() / Globals::BlackHole.Sprite.getHeight();
		BlackHoleFrame = (BlackHoleFrame % NumBlackHoleFrames);
		Globals::BlackHole.Blit(
			Globals::Backbuffer->getHDC(),
			int((Globals::GAME_WIDTH * 0.75f * 0.5f) - (Globals::BlackHole.Sprite.getHeight() / 2)),
			int((Globals::GAME_HEIGHT * 0.75f * 0.5f) + (Globals::GAME_HEIGHT * 0.25f) - (Globals::BlackHole.Sprite.getHeight() / 2)),
			BlackHoleFrame * Globals::BlackHole.Sprite.getHeight(), 0, Globals::BlackHole.Sprite.getHeight(), Globals::BlackHole.Sprite.getHeight());
	}

	for (int i = 0; i < (int)Globals::Objects.size(); ++i)
	{
		DrawObjects(Globals::Objects[i]);

		if (i == 1)
		{
			DrawParticles(Globals::InParticles);
			DrawParticles(Globals::OutParticles);
		}
	}

	// Text example:
	{
		const int MAX_STRING = 256;
		static char HUDString[MAX_STRING];
		//int HUDStrLen = sprintf_s(HUDString, MAX_STRING, "FPS: %f", (1.0f / DeltaTime));
		//int HUDStrLen = sprintf_s(HUDString, MAX_STRING, "1. Drag mail into the sorting machine.\n2. Deliver mail to the correct address.");
		//int HUDStrLen = sprintf_s(HUDString, MAX_STRING, "Good: %d\nBad: %d", Globals::DELIVERY_SUCCESSES, Globals::DELIVERY_FAILURES);
		int HUDStrLen = 0;

		float RemTime = Max(0.0f, Globals::GAME_TIME_LIMIT - AbsTime);
		int Secs = int(RemTime + 0.99f);

		if (!Globals::GAME_STARTED)
		{
			HUDStrLen = sprintf_s(HUDString, MAX_STRING, "INTERPLANETARY\n  POSTAL SERVICE\n    by J. Kyle Pittman\n\nInstructions:\n  1. Drag mail into the sorting machine.\n  2. Deliver sorted mail to the correct address.\n  3. Undeliverable mail goes into the wormhole!\n\n - CLICK ANYWHERE TO START - ");
		}
		else if (!Globals::GAME_OVER)
		{
			HUDStrLen = sprintf_s(HUDString, MAX_STRING, "Time: %d:%02d", Secs/60, Secs%60);
		}
		else
		{
			const int MAX_SHORT_STRING = 16;
			static char Rating1String[MAX_SHORT_STRING];
			static char Rating2String[MAX_SHORT_STRING];
			static char Rating3String[MAX_SHORT_STRING];

			if ((Globals::DELIVERY_SUCCESSES + Globals::DELIVERY_FAILURES) > 0)
			{
				sprintf_s(Rating1String, MAX_SHORT_STRING, "%d / %d (%02d%%)",
					Globals::DELIVERY_SUCCESSES, Globals::DELIVERY_SUCCESSES + Globals::DELIVERY_FAILURES,
					int(100.0f * ((float)Globals::DELIVERY_SUCCESSES / (float)(Globals::DELIVERY_SUCCESSES + Globals::DELIVERY_FAILURES))));
			}
			else
			{
				sprintf_s(Rating1String, MAX_SHORT_STRING, "----");
			}

			if ((Globals::DELIVERY_SATISFIED + Globals::DELIVERY_UNSATISFIED) > 0)
			{
				sprintf_s(Rating2String, MAX_SHORT_STRING, "%d / %d (%02d%%)",
					Globals::DELIVERY_SATISFIED, Globals::DELIVERY_SATISFIED + Globals::DELIVERY_UNSATISFIED,
					int(100.0f * ((float)Globals::DELIVERY_SATISFIED / (float)(Globals::DELIVERY_SATISFIED + Globals::DELIVERY_UNSATISFIED))));
			}
			else
			{
				sprintf_s(Rating2String, MAX_SHORT_STRING, "----");
			}

			if ((Globals::DELIVERY_TOTAL_COUNT) > 0)
			{
				sprintf_s(Rating3String, MAX_SHORT_STRING, "%4.2fs",
					(Globals::DELIVERY_TOTAL_TIME) / (float)(Globals::DELIVERY_TOTAL_COUNT));
			}
			else
			{
				sprintf_s(Rating3String, MAX_SHORT_STRING, "----");
			}

			HUDStrLen = sprintf_s(HUDString, MAX_STRING, "Successful deliveries: %s\nSatisfied customers: %s\nAverage delivery time: %s\n\n - CLICK ANYWHERE TO RESTART - ",
				Rating1String,Rating2String,Rating3String);
		}

		//SetTextColor(Globals::Backbuffer->getHDC(), RGB(96,96,96));
		//TextOut(Globals::Backbuffer->getHDC(), 4 + 1, 4 + 1, HUDString, HUDStrLen);
		//SetTextColor(Globals::Backbuffer->getHDC(), RGB(255,255,255));
		//TextOut(Globals::Backbuffer->getHDC(), 4 + 0, 4 + 0, HUDString, HUDStrLen);

		RECT TextRect;
		TextRect.left = 4 + 1;
		TextRect.right = Globals::GAME_WIDTH - 4 + 1;
		TextRect.top = 4 + 1;
		TextRect.bottom = Globals::GAME_HEIGHT - 4 + 1;

		SetTextColor(Globals::Backbuffer->getHDC(), RGB(80,80,80));
		DrawText(Globals::Backbuffer->getHDC(), HUDString, HUDStrLen, &TextRect, DT_LEFT);

		TextRect.left--;
		TextRect.right--;
		TextRect.top--;
		TextRect.bottom--;

		SetTextColor(Globals::Backbuffer->getHDC(), RGB(255,255,255));
		DrawText(Globals::Backbuffer->getHDC(), HUDString, HUDStrLen, &TextRect, DT_LEFT);
	}
}

bool NeedsRender()
{
	bool bRetVal = false;

	float AbsTime = gTimer->getAbsoluteTime();
	if (AbsTime - Globals::LastRenderTime >= Globals::RENDER_THRESHOLD)
	{
		bRetVal = true;
	}

	return bRetVal;
}

void MainLoop()
{
	while (!Finished())
	{
		gTimer->update();

		if (NeedsRender())
		{
			//float DeltaTime = gTimer->getDeltaTime();
			//float DeltaTime = Globals::RENDER_THRESHOLD;
			float DeltaTime = gTimer->getAbsoluteTime() - Globals::LastRenderTime;

			Globals::LastRenderTime = gTimer->getAbsoluteTime();

			// Blit the previous frame's buffer to the window.
			{
				StretchBlt(
					Globals::gDC, 0, 0, Globals::GAME_WIDTH * Globals::GAME_SCALE, Globals::GAME_HEIGHT * Globals::GAME_SCALE,
					Globals::Backbuffer->getHDC(), 0, 0, Globals::GAME_WIDTH, Globals::GAME_HEIGHT,
					SRCCOPY);
			}

			// Then swap the buffers.
			if (Globals::Backbuffer == &Globals::Backbuffer1)
			{
				Globals::Backbuffer = &Globals::Backbuffer2;
			}
			else
			{
				Globals::Backbuffer = &Globals::Backbuffer1;
			}

			// Now we have a full tick's worth to update the game and draw the scene before we need to blit it.

			// Then update the game.
			UpdateGame(DeltaTime);

			// Then draw the new scene.
			UpdateRender(DeltaTime);

			// (We'll blit the newly updated frame to the window once the next threshold has been hit.)
		}

		//SwitchToThread();
		Sleep(1);
	}
}

void ResetGame()
{
	for (int i = 0; i < (int)Globals::Objects.size(); ++i)
	{
		ClearObjects(Globals::Objects[i]);
	}







	Dome::InitAddresses();

	for (int i = 0; i < Globals::NUM_DOMES; ++i)
	{
		Dome* NewDome = new Dome();
		NewDome->bDraggable = false;
		NewDome->Sprite.Load("dome.bmp", NColor8(255,0,255));
		NewDome->AssignAddress();

		float Angle = ((float(i) / float(Globals::NUM_DOMES))/* + (1.0f / 24.0f)*/) * TAU;
		NVec2 Pos;
		Pos.x = cos(Angle);
		Pos.y = sin(Angle);

		Pos.x *= ((float(Globals::GAME_WIDTH) * 0.75f * 0.5f) - 32.0f);
		Pos.y *= ((float(Globals::GAME_HEIGHT) * 0.75f * 0.5f) - 32.0f);

		Pos.x += (float(Globals::GAME_WIDTH) * 0.75f * 0.5f);
		Pos.y += (float(Globals::GAME_HEIGHT) * 0.75f * 0.5f) + (float(Globals::GAME_HEIGHT) * 0.25f);

		NewDome->Pos.x = Pos.x;
		NewDome->Pos.y = Pos.y;
		NewDome->Extents = NVec2((float)NewDome->Sprite.Sprite.getWidth() * 0.5f, (float)NewDome->Sprite.Sprite.getHeight() * 0.5f);
		Globals::Objects[0].push_back(NewDome);
	}

	{
		Thing* NewSort = new Thing();
		NewSort->bDraggable = false;
		NewSort->Sprite.Load("sort_back.bmp", NColor8(255,0,255));
		NewSort->Pos.x = float(Globals::GAME_WIDTH) * 0.875f;
		NewSort->Pos.y = float(Globals::GAME_HEIGHT / 2);
		NewSort->Extents = NVec2((float)NewSort->Sprite.Sprite.getWidth() * 0.5f, (float)NewSort->Sprite.Sprite.getHeight() * 0.5f);
		Globals::Objects[0].push_back(NewSort);
	}
	{
		Thing* NewSort = new Thing();
		NewSort->bDraggable = false;
		NewSort->Sprite.Load("sort_front.bmp", NColor8(255,0,255));
		NewSort->Pos.x = float(Globals::GAME_WIDTH) * 0.875f;
		NewSort->Pos.y = float(Globals::GAME_HEIGHT / 2);
		NewSort->Extents = NVec2((float)NewSort->Sprite.Sprite.getWidth() * 0.5f, (float)NewSort->Sprite.Sprite.getHeight() * 0.5f);
		Globals::Objects[2].push_back(NewSort);
	}





	gTimer->init();


	Globals::GAME_OVER = false;
	Globals::GAME_STARTED = false;


	Globals::LastRenderTime = -Globals::RENDER_THRESHOLD;
	Globals::LastSortTime = -1000.0f;

	Globals::COMPOSE_THRESHOLD_MIN = Globals::COMPOSE_THRESHOLD_MAX;
	Globals::NextComposeTime = Globals::COMPOSE_THRESHOLD_MAX;
}


void StartGame()
{
	gTimer->init();

	Globals::GAME_STARTED = true;


	Globals::LastRenderTime = -Globals::RENDER_THRESHOLD;
	Globals::LastSortTime = -1000.0f;

	Globals::COMPOSE_THRESHOLD_MIN = Globals::COMPOSE_THRESHOLD_MAX;
	Globals::NextComposeTime = Globals::COMPOSE_THRESHOLD_MAX;

}
