#include "MaskedImage.h"

void MaskedImage::Load(const char* Filename, NColor8 MaskColor)
{
	Sprite.loadBMP(Filename);
	Mask = Sprite;

	for (int y = 0; y < Sprite.getHeight(); ++y)
	{
		for (int x = 0; x < Sprite.getWidth(); ++x)
		{
			if (Sprite.getPixel(x, y) == MaskColor)
			{
				Sprite.setPixel(x, y, NColor8(0));
				Mask.setPixel(x, y, NColor8(255));
			}
			else
			{
				Mask.setPixel(x, y, NColor8(0));
			}
		}
	}
}

void MaskedImage::Blit(HDC dest, int dest_x, int dest_y, int src_x, int src_y, int src_width, int src_height)
{
	BitBlt(
		dest, dest_x, dest_y, src_width, src_height,
		Mask.getHDC(), src_x, src_y, SRCAND);
	BitBlt(
		dest, dest_x, dest_y, src_width, src_height,
		Sprite.getHDC(), src_x, src_y, SRCPAINT);
}
