#include "NColor.h"

NColor8::NColor8(const NColor32f& c) : a(uchar(Clamp((int)(c.a * 255.0f), 0, 255))),
									r(uchar(Clamp((int)(c.r * 255.0f), 0, 255))),
									g(uchar(Clamp((int)(c.g * 255.0f), 0, 255))),
									b(uchar(Clamp((int)(c.b * 255.0f), 0, 255))) {}

NColor32f::NColor32f(const NColor8& c) : a(float(c.a) * (1.0f / 255.0f)),
									  r(float(c.r) * (1.0f / 255.0f)),
									  g(float(c.g) * (1.0f / 255.0f)),
									  b(float(c.b) * (1.0f / 255.0f)) {}


void NColor8::operator *=(const NColor32f& c)	{	r = (uchar)Clamp((int)(float(r) * c.r), 0, 255);
												g = (uchar)Clamp((int)(float(g) * c.g), 0, 255);
												b = (uchar)Clamp((int)(float(b) * c.b), 0, 255);
												a = (uchar)Clamp((int)(float(a) * c.a), 0, 255);}

void NColor8::operator /=(const NColor32f& c)	{	r = (uchar)Clamp((int)(float(r) / c.r), 0, 255);
												g = (uchar)Clamp((int)(float(g) / c.g), 0, 255);
												b = (uchar)Clamp((int)(float(b) / c.b), 0, 255);
												a = (uchar)Clamp((int)(float(a) / c.a), 0, 255);}

byte NColor8::FromHexHelper_HalfByte(const char*& itr)
{
	byte RetVal = 0;
	if (itr && *itr)
	{
		switch (*itr)
		{
		case '0':
			RetVal = 0;
			break;

		case '1':
			RetVal = 1;
			break;

		case '2':
			RetVal = 2;
			break;

		case '3':
			RetVal = 3;
			break;

		case '4':
			RetVal = 4;
			break;

		case '5':
			RetVal = 5;
			break;

		case '6':
			RetVal = 6;
			break;

		case '7':
			RetVal = 7;
			break;

		case '8':
			RetVal = 8;
			break;

		case '9':
			RetVal = 9;
			break;

		case 'a':
			RetVal = 0x0a;
			break;

		case 'A':
			RetVal = 0x0a;
			break;

		case 'b':
			RetVal = 0x0b;
			break;

		case 'B':
			RetVal = 0x0b;
			break;

		case 'c':
			RetVal = 0x0c;
			break;

		case 'C':
			RetVal = 0x0c;
			break;

		case 'd':
			RetVal = 0x0d;
			break;

		case 'D':
			RetVal = 0x0d;
			break;

		case 'e':
			RetVal = 0x0e;
			break;

		case 'E':
			RetVal = 0x0e;
			break;

		case 'f':
			RetVal = 0x0f;
			break;

		case 'F':
			RetVal = 0x0f;
			break;

		default:
			break;
		}

		itr++;
	}
	return RetVal;
}

byte NColor8::FromHexHelper_Byte(const char*& itr)
{
	byte RetVal = 0;
	if (itr && *itr)
	{
		RetVal = (FromHexHelper_HalfByte(itr) << 4);
		RetVal = RetVal | (FromHexHelper_HalfByte(itr));
	}
	return RetVal;
}

NColor8 NColor8::FromHex(const char* HexString)
{
	NColor8 RetVal;

	const char* itr = HexString;
	if (*itr == '#')
	{
		itr++;
	}

	RetVal.r = FromHexHelper_Byte(itr);
	RetVal.g = FromHexHelper_Byte(itr);
	RetVal.b = FromHexHelper_Byte(itr);
	RetVal.a = FromHexHelper_Byte(itr);

	return RetVal;
}
