#pragma once

#include "NWindowsVersion.h"

class NTimer
{
public:
	NTimer() : paused(false) {}

	bool init();												// Inits the timer, returns true on success

	void update();												// Updates delta and absolute times
	void pause();												// Toggle pause
	void pause(bool flag);										// Pauses and unpauses the timer

	float getAbsoluteTime() const;								// Returns the time elapsed since initialization
	float getDeltaTime() const {return float(delta);}			// Returns the delta time

private:
	LONGLONG start;				// Time started
	LONGLONG current;			// Current time

	double res;					// Resolution of timer (1.0 / clock ticks per second)
	double delta;				// Delta time, a time slice between each call
	bool paused;				// True if paused, false otherwise

	LONGLONG paused_at;
	LONGLONG unpaused_at;
};

extern NTimer* gTimer;
